
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_J_jt.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_J_jt.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function J_jt = kin_xyzbc_tt_J_jt(in1,in2)
//
// kin_xyzbc_tt_J_jt
//     J_jt = kin_xyzbc_tt_J_jt(IN1,IN2)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                double J_jt[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_J_jt(const ::coder::array<double, 1U> &in1, const ::coder::array<double, 1U> &in2,
                       double J_jt[5][5])
{
    double J_jt_tmp;
    double b_J_jt_tmp;
    double c_J_jt_tmp;
    double d_J_jt_tmp;
    double e_J_jt_tmp;
    double f_J_jt_tmp;
    double t2;
    double t3;
    double t4;
    double t5;
    double t6;
    double t7;
    double t8;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:34
    // Jacobian Kinematics ( Inverse Kinematics ) :
    // INPUTS :
    // 	r_j    (5x1) : pose vector( joint space )
    // 	v_j    (5x1) : speed vector( joint space )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_J_jt:16' b = in1(4,:);
    // 'kin_xyzbc_tt_J_jt:17' c = in1(5,:);
    // 'kin_xyzbc_tt_J_jt:18' offB1 = in2(10);
    // 'kin_xyzbc_tt_J_jt:19' offC1 = in2(13);
    // 'kin_xyzbc_tt_J_jt:20' offB3 = in2(12);
    // 'kin_xyzbc_tt_J_jt:21' offC2 = in2(14);
    // 'kin_xyzbc_tt_J_jt:22' offC3 = in2(15);
    // 'kin_xyzbc_tt_J_jt:23' offP1 = in2(7);
    // 'kin_xyzbc_tt_J_jt:24' offP2 = in2(8);
    // 'kin_xyzbc_tt_J_jt:25' offP3 = in2(9);
    // 'kin_xyzbc_tt_J_jt:26' x = in1(1,:);
    // 'kin_xyzbc_tt_J_jt:27' y = in1(2,:);
    // 'kin_xyzbc_tt_J_jt:28' z = in1(3,:);
    // 'kin_xyzbc_tt_J_jt:29' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_J_jt:30' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_J_jt:31' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_J_jt:32' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_J_jt:33' t6 = offP1+x;
    t6 = in1[0] + in2[6];
    // 'kin_xyzbc_tt_J_jt:34' t7 = offP2+y;
    t7 = in1[1] + in2[7];
    // 'kin_xyzbc_tt_J_jt:35' t8 = offP3+z;
    t8 = in1[2] + in2[8];
    // 'kin_xyzbc_tt_J_jt:36' J_jt =
    // reshape([t2.*t3,t5,-t3.*t4,0.0,0.0,-t2.*t5,t3,t4.*t5,0.0,0.0,t4,0.0,t2,0.0,0.0,-offB1.*t4+offB3.*t2+offC3.*t2+t2.*t8-offC1.*t3.*t4+offC2.*t4.*t5-t3.*t4.*t6+t4.*t5.*t7,0.0,-offB1.*t2-offB3.*t4-offC3.*t4-t4.*t8-offC1.*t2.*t3+offC2.*t2.*t5-t2.*t3.*t6+t2.*t5.*t7,1.0,0.0,-offC2.*t2.*t3-offC1.*t2.*t5-t2.*t3.*t7-t2.*t5.*t6,offC1.*t3-offC2.*t5+t3.*t6-t5.*t7,offC2.*t3.*t4+offC1.*t4.*t5+t3.*t4.*t7+t4.*t5.*t6,0.0,1.0],[5,5]);
    J_jt_tmp = t2 * t3;
    J_jt[0][0] = J_jt_tmp;
    J_jt[0][1] = t5;
    J_jt[0][2] = -t3 * t4;
    J_jt[0][3] = 0.0;
    J_jt[0][4] = 0.0;
    J_jt[1][0] = -t2 * t5;
    J_jt[1][1] = t3;
    b_J_jt_tmp = t4 * t5;
    J_jt[1][2] = b_J_jt_tmp;
    J_jt[1][3] = 0.0;
    J_jt[1][4] = 0.0;
    J_jt[2][0] = t4;
    J_jt[2][1] = 0.0;
    J_jt[2][2] = t2;
    J_jt[2][3] = 0.0;
    J_jt[2][4] = 0.0;
    c_J_jt_tmp = in2[12] * t3;
    d_J_jt_tmp = t3 * t4;
    J_jt[3][0] = ((((((-in2[9] * t4 + in2[11] * t2) + in2[14] * t2) + t2 * t8) - c_J_jt_tmp * t4) +
                   in2[13] * t4 * t5) -
                  d_J_jt_tmp * t6) +
                 b_J_jt_tmp * t7;
    J_jt[3][1] = 0.0;
    e_J_jt_tmp = in2[12] * t2;
    f_J_jt_tmp = t2 * t5;
    J_jt[3][2] = ((((((-in2[9] * t2 - in2[11] * t4) - in2[14] * t4) - t4 * t8) - e_J_jt_tmp * t3) +
                   in2[13] * t2 * t5) -
                  J_jt_tmp * t6) +
                 f_J_jt_tmp * t7;
    J_jt[3][3] = 1.0;
    J_jt[3][4] = 0.0;
    J_jt[4][0] = ((-in2[13] * t2 * t3 - e_J_jt_tmp * t5) - J_jt_tmp * t7) - f_J_jt_tmp * t6;
    J_jt[4][1] = ((c_J_jt_tmp - in2[13] * t5) + t3 * t6) - t5 * t7;
    J_jt[4][2] = ((in2[13] * t3 * t4 + in2[12] * t4 * t5) + d_J_jt_tmp * t7) + b_J_jt_tmp * t6;
    J_jt[4][3] = 0.0;
    J_jt[4][4] = 1.0;
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_J_jt.cpp
//
// [EOF]
//
